diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/media.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/media.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/media.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/media.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 7,17 ****
   */
  
  /**
!  * {@internal Missing Short Description}}
   *
   * @since 2.5.0
   *
!  * @return unknown
   */
  function media_upload_tabs() {
  	$_default_tabs = array(
--- 7,17 ----
   */
  
  /**
!  * Defines the default media upload tabs
   *
   * @since 2.5.0
   *
!  * @return array default tabs
   */
  function media_upload_tabs() {
  	$_default_tabs = array(
***************
*** 25,36 ****
  }
  
  /**
!  * {@internal Missing Short Description}}
   *
   * @since 2.5.0
   *
!  * @param unknown_type $tabs
!  * @return unknown
   */
  function update_gallery_tab($tabs) {
  	global $wpdb;
--- 25,36 ----
  }
  
  /**
!  * Adds the gallery tab back to the tabs array if post has image attachments
   *
   * @since 2.5.0
   *
!  * @param array $tabs
!  * @return array $tabs with gallery if post has image attachment
   */
  function update_gallery_tab($tabs) {
  	global $wpdb;
***************
*** 94,111 ****
   *
   * @since 2.5.0
   *
!  * @param unknown_type $id
!  * @param unknown_type $alt
!  * @param unknown_type $title
!  * @param unknown_type $align
!  * @param unknown_type $url
!  * @param unknown_type $rel
!  * @param unknown_type $size
!  * @return unknown
   */
  function get_image_send_to_editor($id, $caption, $title, $align, $url='', $rel = false, $size='medium', $alt = '') {
  
! 	$html = get_image_tag($id, $alt, $title, $align, $size);
  
  	$rel = $rel ? ' rel="attachment wp-att-' . esc_attr($id).'"' : '';
  
--- 94,112 ----
   *
   * @since 2.5.0
   *
!  * @param integer $id image attachment id
!  * @param string $caption image caption
!  * @param string $alt image alt attribute
!  * @param string $title image title attribute
!  * @param string $align image css alignment property
!  * @param string $url image src url
!  * @param string|bool $rel image rel attribute
!  * @param string $size image size (thumbnail, medium, large, full or added  with add_image_size() )
!  * @return string the html to insert into editor
   */
  function get_image_send_to_editor($id, $caption, $title, $align, $url='', $rel = false, $size='medium', $alt = '') {
  
! 	$html = get_image_tag($id, $alt, '', $align, $size);
  
  	$rel = $rel ? ' rel="attachment wp-att-' . esc_attr($id).'"' : '';
  
***************
*** 118,135 ****
  }
  
  /**
!  * {@internal Missing Short Description}}
   *
   * @since 2.6.0
   *
!  * @param unknown_type $html
!  * @param unknown_type $id
!  * @param unknown_type $alt
!  * @param unknown_type $title
!  * @param unknown_type $align
!  * @param unknown_type $url
!  * @param unknown_type $size
!  * @return unknown
   */
  function image_add_caption( $html, $id, $caption, $title, $align, $url, $size, $alt = '' ) {
  
--- 119,137 ----
  }
  
  /**
!  * Adds image shortcode with caption to editor
   *
   * @since 2.6.0
   *
!  * @param string $html
!  * @param integer $id
!  * @param string $caption image caption
!  * @param string $alt image alt attribute
!  * @param string $title image title attribute
!  * @param string $align image css alignment property
!  * @param string $url image src url
!  * @param string $size image size (thumbnail, medium, large, full or added with add_image_size() )
!  * @return string
   */
  function image_add_caption( $html, $id, $caption, $title, $align, $url, $size, $alt = '' ) {
  
***************
*** 170,180 ****
  }
  
  /**
!  * {@internal Missing Short Description}}
   *
   * @since 2.5.0
   *
!  * @param unknown_type $html
   */
  function media_send_to_editor($html) {
  ?>
--- 172,182 ----
  }
  
  /**
!  * Adds image html to editor
   *
   * @since 2.5.0
   *
!  * @param string $html
   */
  function media_send_to_editor($html) {
  ?>
***************
*** 189,196 ****
  }
  
  /**
-  * {@internal Missing Short Description}}
-  *
   * This handles the file upload POST itself, creating the attachment post.
   *
   * @since 2.5.0
--- 191,196 ----
***************
*** 269,275 ****
  function media_handle_sideload($file_array, $post_id, $desc = null, $post_data = array()) {
  	$overrides = array('test_form'=>false);
  
! 	$file = wp_handle_sideload($file_array, $overrides);
  	if ( isset($file['error']) )
  		return new WP_Error( 'upload_error', $file['error'] );
  
--- 269,281 ----
  function media_handle_sideload($file_array, $post_id, $desc = null, $post_data = array()) {
  	$overrides = array('test_form'=>false);
  
! 	$time = current_time( 'mysql' );
! 	if ( $post = get_post( $post_id ) ) {
! 		if ( substr( $post->post_date, 0, 4 ) > 0 )
! 			$time = $post->post_date;
! 	}
! 
! 	$file = wp_handle_sideload( $file_array, $overrides, $time );
  	if ( isset($file['error']) )
  		return new WP_Error( 'upload_error', $file['error'] );
  
***************
*** 312,325 ****
  }
  
  /**
!  * {@internal Missing Short Description}}
!  *
!  * Wrap iframe content (produced by $content_func) in a doctype, html head/body
!  * etc any additional function args will be passed to content_func.
   *
   * @since 2.5.0
   *
!  * @param unknown_type $content_func
   */
  function wp_iframe($content_func /* ... */) {
  	_wp_admin_html_begin();
--- 318,328 ----
  }
  
  /**
!  * Adds the iframe to display content for the media upload page
   *
   * @since 2.5.0
   *
!  * @param array $content_func
   */
  function wp_iframe($content_func /* ... */) {
  	_wp_admin_html_begin();
***************
*** 355,361 ****
  	do_action( "admin_head_{$content_func}" );
  ?>
  </head>
! <body<?php if ( isset($GLOBALS['body_id']) ) echo ' id="' . $GLOBALS['body_id'] . '"'; ?> class="no-js">
  <script type="text/javascript">
  document.body.className = document.body.className.replace('no-js', 'js');
  </script>
--- 358,364 ----
  	do_action( "admin_head_{$content_func}" );
  ?>
  </head>
! <body<?php if ( isset($GLOBALS['body_id']) ) echo ' id="' . $GLOBALS['body_id'] . '"'; ?> class="wp-core-ui no-js">
  <script type="text/javascript">
  document.body.className = document.body.className.replace('no-js', 'js');
  </script>
***************
*** 373,395 ****
  }
  
  /**
!  * {@internal Missing Short Description}}
   *
   * @since 2.5.0
   */
  function media_buttons($editor_id = 'content') {
! 	$context = apply_filters('media_buttons_context', __('Upload/Insert %s'));
! 
! 	$img = '<img src="' . esc_url( admin_url( 'images/media-button.png?ver=20111005' ) ) . '" width="15" height="15" />';
! 
! 	echo '<a href="' . esc_url( get_upload_iframe_src() ) . '" class="thickbox add_media" id="' . esc_attr( $editor_id ) . '-add_media" title="' . esc_attr__( 'Add Media' ) . '" onclick="return false;">' . sprintf( $context, $img ) . '</a>';
  }
  add_action( 'media_buttons', 'media_buttons' );
  
- function _media_button($title, $icon, $type, $id) {
- 	return "<a href='" . esc_url( get_upload_iframe_src($type) ) . "' id='{$id}-add_{$type}' class='thickbox add_$type' title='" . esc_attr( $title ) . "'><img src='" . esc_url( admin_url( $icon ) ) . "' alt='$title' onclick='return false;' /></a>";
- }
- 
  function get_upload_iframe_src( $type = null, $post_id = null, $tab = null ) {
  	global $post_ID;
  
--- 376,412 ----
  }
  
  /**
!  * Adds the media button to the editor
   *
   * @since 2.5.0
+  *
+  * @param string $editor_id
   */
  function media_buttons($editor_id = 'content') {
! 	$post = get_post();
! 	if ( ! $post && ! empty( $GLOBALS['post_ID'] ) )
! 		$post = $GLOBALS['post_ID'];
! 
! 	wp_enqueue_media( array(
! 		'post' => $post
! 	) );
! 
! 	$img = '<span class="wp-media-buttons-icon"></span> ';
! 
! 	echo '<a href="#" class="button insert-media add_media" data-editor="' . esc_attr( $editor_id ) . '" title="' . esc_attr__( 'Add Media' ) . '">' . $img . __( 'Add Media' ) . '</a>';
! 
! 	// Don't use this filter. Want to add a button? Use the media_buttons action.
! 	$legacy_filter = apply_filters('media_buttons_context', ''); // deprecated
! 
! 	if ( $legacy_filter ) {
! 		// #WP22559. Close <a> if a plugin started by closing <a> to open their own <a> tag.
! 		if ( 0 === stripos( trim( $legacy_filter ), '</a>' ) )
! 			$legacy_filter .= '</a>';
! 		echo $legacy_filter;
! 	}
  }
  add_action( 'media_buttons', 'media_buttons' );
  
  function get_upload_iframe_src( $type = null, $post_id = null, $tab = null ) {
  	global $post_ID;
  
***************
*** 414,420 ****
   *
   * @since 2.5.0
   *
!  * @return unknown
   */
  function media_upload_form_handler() {
  	check_admin_referer('media-form');
--- 431,437 ----
   *
   * @since 2.5.0
   *
!  * @return mixed void|object WP_Error on failure
   */
  function media_upload_form_handler() {
  	check_admin_referer('media-form');
***************
*** 506,512 ****
   *
   * @since 2.5.0
   *
!  * @return unknown
   */
  function wp_media_upload_handler() {
  	$errors = array();
--- 523,529 ----
   *
   * @since 2.5.0
   *
!  * @return mixed
   */
  function wp_media_upload_handler() {
  	$errors = array();
***************
*** 599,605 ****
  
  		// Set variables for storage
  		// fix file filename for query strings
! 		preg_match('/[^\?]+\.(jpg|JPG|jpe|JPE|jpeg|JPEG|gif|GIF|png|PNG)/', $file, $matches);
  		$file_array['name'] = basename($matches[0]);
  		$file_array['tmp_name'] = $tmp;
  
--- 616,622 ----
  
  		// Set variables for storage
  		// fix file filename for query strings
! 		preg_match( '/[^\?]+\.(jpe?g|jpe|gif|png)\b/i', $file, $matches );
  		$file_array['name'] = basename($matches[0]);
  		$file_array['tmp_name'] = $tmp;
  
***************
*** 677,685 ****
   *
   * @since 2.7.0
   *
!  * @param unknown_type $post
!  * @param unknown_type $checked
!  * @return unknown
   */
  function image_align_input_fields( $post, $checked = '' ) {
  
--- 694,702 ----
   *
   * @since 2.7.0
   *
!  * @param object $post
!  * @param string $checked
!  * @return string
   */
  function image_align_input_fields( $post, $checked = '' ) {
  
***************
*** 705,713 ****
   *
   * @since 2.7.0
   *
!  * @param unknown_type $post
!  * @param unknown_type $check
!  * @return unknown
   */
  function image_size_input_fields( $post, $check = '' ) {
  
--- 722,730 ----
   *
   * @since 2.7.0
   *
!  * @param object $post
!  * @param bool|string $check
!  * @return array
   */
  function image_size_input_fields( $post, $check = '' ) {
  
***************
*** 760,768 ****
   *
   * @since 2.7.0
   *
!  * @param unknown_type $post
!  * @param unknown_type $url_type
!  * @return unknown
   */
  function image_link_input_fields($post, $url_type = '') {
  
--- 777,785 ----
   *
   * @since 2.7.0
   *
!  * @param object $post
!  * @param string $url_type
!  * @return string
   */
  function image_link_input_fields($post, $url_type = '') {
  
***************
*** 798,845 ****
   *
   * @since 2.5.0
   *
!  * @param unknown_type $form_fields
!  * @param unknown_type $post
!  * @return unknown
   */
  function image_attachment_fields_to_edit($form_fields, $post) {
- 	if ( substr($post->post_mime_type, 0, 5) == 'image' ) {
- 		$alt = get_post_meta($post->ID, '_wp_attachment_image_alt', true);
- 		if ( empty($alt) )
- 			$alt = '';
- 
- 		$form_fields['post_title']['required'] = true;
- 
- 		$form_fields['image_alt'] = array(
- 			'value' => $alt,
- 			'label' => __('Alternate Text'),
- 			'helps' => __('Alt text for the image, e.g. &#8220;The Mona Lisa&#8221;')
- 		);
- 
- 		$form_fields['align'] = array(
- 			'label' => __('Alignment'),
- 			'input' => 'html',
- 			'html'  => image_align_input_fields($post, get_option('image_default_align')),
- 		);
- 
- 		$form_fields['image-size'] = image_size_input_fields( $post, get_option('image_default_size', 'medium') );
- 
- 	} else {
- 		unset( $form_fields['image_alt'] );
- 	}
  	return $form_fields;
  }
  
- add_filter('attachment_fields_to_edit', 'image_attachment_fields_to_edit', 10, 2);
- 
  /**
   * {@internal Missing Short Description}}
   *
   * @since 2.5.0
   *
!  * @param unknown_type $form_fields
!  * @param unknown_type $post
!  * @return unknown
   */
  function media_single_attachment_fields_to_edit( $form_fields, $post ) {
  	unset($form_fields['url'], $form_fields['align'], $form_fields['image-size']);
--- 815,836 ----
   *
   * @since 2.5.0
   *
!  * @param array $form_fields
!  * @param object $post
!  * @return array
   */
  function image_attachment_fields_to_edit($form_fields, $post) {
  	return $form_fields;
  }
  
  /**
   * {@internal Missing Short Description}}
   *
   * @since 2.5.0
   *
!  * @param array $form_fields
!  * @param object $post {@internal $post not used}}
!  * @return array
   */
  function media_single_attachment_fields_to_edit( $form_fields, $post ) {
  	unset($form_fields['url'], $form_fields['align'], $form_fields['image-size']);
***************
*** 851,859 ****
   *
   * @since 2.8.0
   *
!  * @param unknown_type $form_fields
!  * @param unknown_type $post
!  * @return unknown
   */
  function media_post_single_attachment_fields_to_edit( $form_fields, $post ) {
  	unset($form_fields['image_url']);
--- 842,850 ----
   *
   * @since 2.8.0
   *
!  * @param array $form_fields
!  * @param object $post {@internal $post not used}}
!  * @return array
   */
  function media_post_single_attachment_fields_to_edit( $form_fields, $post ) {
  	unset($form_fields['image_url']);
***************
*** 861,873 ****
  }
  
  /**
!  * {@internal Missing Short Description}}
   *
   * @since 2.5.0
   *
!  * @param unknown_type $post
!  * @param unknown_type $attachment
!  * @return unknown
   */
  function image_attachment_fields_to_save($post, $attachment) {
  	if ( substr($post['post_mime_type'], 0, 5) == 'image' ) {
--- 852,868 ----
  }
  
  /**
!  * Filters input from media_upload_form_handler() and assigns a default
!  * post_title from the file name if none supplied.
!  *
!  * Illustrates the use of the attachment_fields_to_save filter
!  * which can be used to add default values to any field before saving to DB.
   *
   * @since 2.5.0
   *
!  * @param object $post
!  * @param array $attachment {@internal $attachment not used}}
!  * @return array
   */
  function image_attachment_fields_to_save($post, $attachment) {
  	if ( substr($post['post_mime_type'], 0, 5) == 'image' ) {
***************
*** 887,899 ****
   *
   * @since 2.5.0
   *
!  * @param unknown_type $html
!  * @param unknown_type $attachment_id
!  * @param unknown_type $attachment
!  * @return unknown
   */
  function image_media_send_to_editor($html, $attachment_id, $attachment) {
! 	$post =& get_post($attachment_id);
  	if ( substr($post->post_mime_type, 0, 5) == 'image' ) {
  		$url = $attachment['url'];
  		$align = !empty($attachment['align']) ? $attachment['align'] : 'none';
--- 882,894 ----
   *
   * @since 2.5.0
   *
!  * @param string $html
!  * @param integer $attachment_id
!  * @param array $attachment
!  * @return array
   */
  function image_media_send_to_editor($html, $attachment_id, $attachment) {
! 	$post = get_post($attachment_id);
  	if ( substr($post->post_mime_type, 0, 5) == 'image' ) {
  		$url = $attachment['url'];
  		$align = !empty($attachment['align']) ? $attachment['align'] : 'none';
***************
*** 914,928 ****
   *
   * @since 2.5.0
   *
!  * @param unknown_type $post
!  * @param unknown_type $errors
!  * @return unknown
   */
  function get_attachment_fields_to_edit($post, $errors = null) {
  	if ( is_int($post) )
! 		$post =& get_post($post);
  	if ( is_array($post) )
! 		$post = (object) $post;
  
  	$image_url = wp_get_attachment_url($post->ID);
  
--- 909,923 ----
   *
   * @since 2.5.0
   *
!  * @param object $post
!  * @param array $errors
!  * @return array
   */
  function get_attachment_fields_to_edit($post, $errors = null) {
  	if ( is_int($post) )
! 		$post = get_post($post);
  	if ( is_array($post) )
! 		$post = new WP_Post( (object) $post );
  
  	$image_url = wp_get_attachment_url($post->ID);
  
***************
*** 965,971 ****
  
  	foreach ( get_attachment_taxonomies($post) as $taxonomy ) {
  		$t = (array) get_taxonomy($taxonomy);
! 		if ( ! $t['public'] )
  			continue;
  		if ( empty($t['label']) )
  			$t['label'] = $taxonomy;
--- 960,966 ----
  
  	foreach ( get_attachment_taxonomies($post) as $taxonomy ) {
  		$t = (array) get_taxonomy($taxonomy);
! 		if ( ! $t['public'] || ! $t['show_ui'] )
  			continue;
  		if ( empty($t['label']) )
  			$t['label'] = $taxonomy;
***************
*** 973,985 ****
  			$t['args'] = array();
  
  		$terms = get_object_term_cache($post->ID, $taxonomy);
! 		if ( empty($terms) )
  			$terms = wp_get_object_terms($post->ID, $taxonomy, $t['args']);
  
  		$values = array();
  
  		foreach ( $terms as $term )
! 			$values[] = $term->name;
  		$t['value'] = join(', ', $values);
  
  		$form_fields[$taxonomy] = $t;
--- 968,980 ----
  			$t['args'] = array();
  
  		$terms = get_object_term_cache($post->ID, $taxonomy);
! 		if ( false === $terms )
  			$terms = wp_get_object_terms($post->ID, $taxonomy, $t['args']);
  
  		$values = array();
  
  		foreach ( $terms as $term )
! 			$values[] = $term->slug;
  		$t['value'] = join(', ', $values);
  
  		$form_fields[$taxonomy] = $t;
***************
*** 989,994 ****
--- 984,1015 ----
  	// The recursive merge is easily traversed with array casting: foreach( (array) $things as $thing )
  	$form_fields = array_merge_recursive($form_fields, (array) $errors);
  
+ 	// This was formerly in image_attachment_fields_to_edit().
+ 	if ( substr($post->post_mime_type, 0, 5) == 'image' ) {
+ 		$alt = get_post_meta($post->ID, '_wp_attachment_image_alt', true);
+ 		if ( empty($alt) )
+ 			$alt = '';
+ 
+ 		$form_fields['post_title']['required'] = true;
+ 
+ 		$form_fields['image_alt'] = array(
+ 			'value' => $alt,
+ 			'label' => __('Alternative Text'),
+ 			'helps' => __('Alt text for the image, e.g. &#8220;The Mona Lisa&#8221;')
+ 		);
+ 
+ 		$form_fields['align'] = array(
+ 			'label' => __('Alignment'),
+ 			'input' => 'html',
+ 			'html'  => image_align_input_fields($post, get_option('image_default_align')),
+ 		);
+ 
+ 		$form_fields['image-size'] = image_size_input_fields( $post, get_option('image_default_size', 'medium') );
+ 
+ 	} else {
+ 		unset( $form_fields['image_alt'] );
+ 	}
+ 
  	$form_fields = apply_filters('attachment_fields_to_edit', $form_fields, $post);
  
  	return $form_fields;
***************
*** 1060,1066 ****
  	$toggle_on  = __( 'Show' );
  	$toggle_off = __( 'Hide' );
  
! 	$filename = esc_html( basename( $post->guid ) );
  	$title = esc_attr( $post->post_title );
  
  	if ( $_tags = get_the_tags( $attachment_id ) ) {
--- 1081,1087 ----
  	$toggle_on  = __( 'Show' );
  	$toggle_off = __( 'Hide' );
  
! 	$filename = esc_html( wp_basename( $post->guid ) );
  	$title = esc_attr( $post->post_title );
  
  	if ( $_tags = get_the_tags( $attachment_id ) ) {
***************
*** 1111,1119 ****
  	$media_dims = apply_filters( 'media_meta', $media_dims, $post );
  
  	$image_edit_button = '';
! 	if ( gd_edit_image_support( $post->post_mime_type ) ) {
  		$nonce = wp_create_nonce( "image_editor-$post->ID" );
! 		$image_edit_button = "<input type='button' id='imgedit-open-btn-$post->ID' onclick='imageEdit.open( $post->ID, \"$nonce\" )' class='button' value='" . esc_attr__( 'Edit Image' ) . "' /> <img src='" . esc_url( admin_url( 'images/wpspin_light.gif' ) ) . "' class='imgedit-wait-spin' alt='' />";
  	}
  
  	$attachment_url = get_permalink( $attachment_id );
--- 1132,1140 ----
  	$media_dims = apply_filters( 'media_meta', $media_dims, $post );
  
  	$image_edit_button = '';
! 	if ( wp_attachment_is_image( $post->ID ) && wp_image_editor_supports( array( 'mime_type' => $post->post_mime_type ) ) ) {
  		$nonce = wp_create_nonce( "image_editor-$post->ID" );
! 		$image_edit_button = "<input type='button' id='imgedit-open-btn-$post->ID' onclick='imageEdit.open( $post->ID, \"$nonce\" )' class='button' value='" . esc_attr__( 'Edit Image' ) . "' /> <span class='spinner'></span>";
  	}
  
  	$attachment_url = get_permalink( $attachment_id );
***************
*** 1156,1171 ****
  		$send = get_submit_button( __( 'Insert into Post' ), 'button', "send[$attachment_id]", false );
  	if ( $delete && current_user_can( 'delete_post', $attachment_id ) ) {
  		if ( !EMPTY_TRASH_DAYS ) {
! 			$delete = "<a href='" . wp_nonce_url( "post.php?action=delete&amp;post=$attachment_id", 'delete-attachment_' . $attachment_id ) . "' id='del[$attachment_id]' class='delete'>" . __( 'Delete Permanently' ) . '</a>';
  		} elseif ( !MEDIA_TRASH ) {
  			$delete = "<a href='#' class='del-link' onclick=\"document.getElementById('del_attachment_$attachment_id').style.display='block';return false;\">" . __( 'Delete' ) . "</a>
  			 <div id='del_attachment_$attachment_id' class='del-attachment' style='display:none;'><p>" . sprintf( __( 'You are about to delete <strong>%s</strong>.' ), $filename ) . "</p>
! 			 <a href='" . wp_nonce_url( "post.php?action=delete&amp;post=$attachment_id", 'delete-attachment_' . $attachment_id ) . "' id='del[$attachment_id]' class='button'>" . __( 'Continue' ) . "</a>
  			 <a href='#' class='button' onclick=\"this.parentNode.style.display='none';return false;\">" . __( 'Cancel' ) . "</a>
  			 </div>";
  		} else {
! 			$delete = "<a href='" . wp_nonce_url( "post.php?action=trash&amp;post=$attachment_id", 'trash-attachment_' . $attachment_id ) . "' id='del[$attachment_id]' class='delete'>" . __( 'Move to Trash' ) . "</a>
! 			<a href='" . wp_nonce_url( "post.php?action=untrash&amp;post=$attachment_id", 'untrash-attachment_' . $attachment_id ) . "' id='undo[$attachment_id]' class='undo hidden'>" . __( 'Undo' ) . "</a>";
  		}
  	} else {
  		$delete = '';
--- 1177,1192 ----
  		$send = get_submit_button( __( 'Insert into Post' ), 'button', "send[$attachment_id]", false );
  	if ( $delete && current_user_can( 'delete_post', $attachment_id ) ) {
  		if ( !EMPTY_TRASH_DAYS ) {
! 			$delete = "<a href='" . wp_nonce_url( "post.php?action=delete&amp;post=$attachment_id", 'delete-post_' . $attachment_id ) . "' id='del[$attachment_id]' class='delete-permanently'>" . __( 'Delete Permanently' ) . '</a>';
  		} elseif ( !MEDIA_TRASH ) {
  			$delete = "<a href='#' class='del-link' onclick=\"document.getElementById('del_attachment_$attachment_id').style.display='block';return false;\">" . __( 'Delete' ) . "</a>
  			 <div id='del_attachment_$attachment_id' class='del-attachment' style='display:none;'><p>" . sprintf( __( 'You are about to delete <strong>%s</strong>.' ), $filename ) . "</p>
! 			 <a href='" . wp_nonce_url( "post.php?action=delete&amp;post=$attachment_id", 'delete-post_' . $attachment_id ) . "' id='del[$attachment_id]' class='button'>" . __( 'Continue' ) . "</a>
  			 <a href='#' class='button' onclick=\"this.parentNode.style.display='none';return false;\">" . __( 'Cancel' ) . "</a>
  			 </div>";
  		} else {
! 			$delete = "<a href='" . wp_nonce_url( "post.php?action=trash&amp;post=$attachment_id", 'trash-post_' . $attachment_id ) . "' id='del[$attachment_id]' class='delete'>" . __( 'Move to Trash' ) . "</a>
! 			<a href='" . wp_nonce_url( "post.php?action=untrash&amp;post=$attachment_id", 'untrash-post_' . $attachment_id ) . "' id='undo[$attachment_id]' class='undo hidden'>" . __( 'Undo' ) . "</a>";
  		}
  	} else {
  		$delete = '';
***************
*** 1260,1277 ****
  	return $item;
  }
  
  /**
   * {@internal Missing Short Description}}
   *
   * @since 2.5.0
   */
  function media_upload_header() {
! 	?>
! 	<script type="text/javascript">post_id = <?php echo intval($_REQUEST['post_id']); ?>;</script>
! 	<div id="media-upload-header">
! 	<?php the_media_upload_tabs(); ?>
! 	</div>
! 	<?php
  }
  
  /**
--- 1281,1441 ----
  	return $item;
  }
  
+ function get_compat_media_markup( $attachment_id, $args = null ) {
+ 	$post = get_post( $attachment_id );
+ 
+ 	$default_args = array(
+ 		'errors' => null,
+ 		'in_modal' => false,
+ 	);
+ 
+ 	$user_can_edit = current_user_can( 'edit_post', $attachment_id );
+ 
+ 	$args = wp_parse_args( $args, $default_args );
+ 	$args = apply_filters( 'get_media_item_args', $args );
+ 
+ 	$form_fields = array();
+ 
+ 	if ( $args['in_modal'] ) {
+ 		foreach ( get_attachment_taxonomies($post) as $taxonomy ) {
+ 			$t = (array) get_taxonomy($taxonomy);
+ 			if ( ! $t['public'] || ! $t['show_ui'] )
+ 				continue;
+ 			if ( empty($t['label']) )
+ 				$t['label'] = $taxonomy;
+ 			if ( empty($t['args']) )
+ 				$t['args'] = array();
+ 
+ 			$terms = get_object_term_cache($post->ID, $taxonomy);
+ 			if ( false === $terms )
+ 				$terms = wp_get_object_terms($post->ID, $taxonomy, $t['args']);
+ 
+ 			$values = array();
+ 
+ 			foreach ( $terms as $term )
+ 				$values[] = $term->slug;
+ 			$t['value'] = join(', ', $values);
+ 			$t['taxonomy'] = true;
+ 
+ 			$form_fields[$taxonomy] = $t;
+ 		}
+ 	}
+ 
+ 	// Merge default fields with their errors, so any key passed with the error (e.g. 'error', 'helps', 'value') will replace the default
+ 	// The recursive merge is easily traversed with array casting: foreach( (array) $things as $thing )
+ 	$form_fields = array_merge_recursive($form_fields, (array) $args['errors'] );
+ 
+ 	$form_fields = apply_filters( 'attachment_fields_to_edit', $form_fields, $post );
+ 
+ 	unset( $form_fields['image-size'], $form_fields['align'], $form_fields['image_alt'],
+ 		$form_fields['post_title'], $form_fields['post_excerpt'], $form_fields['post_content'],
+ 		$form_fields['url'], $form_fields['menu_order'], $form_fields['image_url'] );
+ 
+ 	$media_meta = apply_filters( 'media_meta', '', $post );
+ 
+ 	$defaults = array(
+ 		'input'         => 'text',
+  		'required'      => false,
+  		'value'         => '',
+  		'extra_rows'    => array(),
+  		'show_in_edit'  => true,
+  		'show_in_modal' => true,
+ 	);
+ 
+ 	$hidden_fields = array();
+ 
+ 	$item = '';
+ 	foreach ( $form_fields as $id => $field ) {
+ 		if ( $id[0] == '_' )
+ 			continue;
+ 
+ 		$name = "attachments[$attachment_id][$id]";
+ 		$id_attr = "attachments-$attachment_id-$id";
+ 
+ 		if ( !empty( $field['tr'] ) ) {
+ 			$item .= $field['tr'];
+ 			continue;
+ 		}
+ 
+ 		$field = array_merge( $defaults, $field );
+ 
+ 		if ( ( ! $field['show_in_edit'] && ! $args['in_modal'] ) || ( ! $field['show_in_modal'] && $args['in_modal'] ) )
+ 			continue;
+ 
+ 		if ( $field['input'] == 'hidden' ) {
+ 			$hidden_fields[$name] = $field['value'];
+ 			continue;
+ 		}
+ 
+ 		$readonly      = ! $user_can_edit && ! empty( $field['taxonomy'] ) ? " readonly='readonly' " : '';
+ 		$required      = $field['required'] ? '<span class="alignright"><abbr title="required" class="required">*</abbr></span>' : '';
+ 		$aria_required = $field['required'] ? " aria-required='true' " : '';
+ 		$class  = 'compat-field-' . $id;
+ 		$class .= $field['required'] ? ' form-required' : '';
+ 
+ 		$item .= "\t\t<tr class='$class'>";
+ 		$item .= "\t\t\t<th valign='top' scope='row' class='label'><label for='$id_attr'><span class='alignleft'>{$field['label']}</span>$required<br class='clear' /></label>";
+ 		$item .= "</th>\n\t\t\t<td class='field'>";
+ 
+ 		if ( !empty( $field[ $field['input'] ] ) )
+ 			$item .= $field[ $field['input'] ];
+ 		elseif ( $field['input'] == 'textarea' ) {
+ 			if ( 'post_content' == $id && user_can_richedit() ) {
+ 				// sanitize_post() skips the post_content when user_can_richedit
+ 				$field['value'] = htmlspecialchars( $field['value'], ENT_QUOTES );
+ 			}
+ 			$item .= "<textarea id='$id_attr' name='$name' $aria_required>" . $field['value'] . '</textarea>';
+ 		} else {
+ 			$item .= "<input type='text' class='text' id='$id_attr' name='$name' value='" . esc_attr( $field['value'] ) . "' $readonly $aria_required />";
+ 		}
+ 		if ( !empty( $field['helps'] ) )
+ 			$item .= "<p class='help'>" . join( "</p>\n<p class='help'>", array_unique( (array) $field['helps'] ) ) . '</p>';
+ 		$item .= "</td>\n\t\t</tr>\n";
+ 
+ 		$extra_rows = array();
+ 
+ 		if ( !empty( $field['errors'] ) )
+ 			foreach ( array_unique( (array) $field['errors'] ) as $error )
+ 				$extra_rows['error'][] = $error;
+ 
+ 		if ( !empty( $field['extra_rows'] ) )
+ 			foreach ( $field['extra_rows'] as $class => $rows )
+ 				foreach ( (array) $rows as $html )
+ 					$extra_rows[$class][] = $html;
+ 
+ 		foreach ( $extra_rows as $class => $rows )
+ 			foreach ( $rows as $html )
+ 				$item .= "\t\t<tr><td></td><td class='$class'>$html</td></tr>\n";
+ 	}
+ 
+ 	if ( !empty( $form_fields['_final'] ) )
+ 		$item .= "\t\t<tr class='final'><td colspan='2'>{$form_fields['_final']}</td></tr>\n";
+ 	if ( $item )
+ 		$item = '<table class="compat-attachment-fields">' . $item . '</table>';
+ 
+ 	foreach ( $hidden_fields as $hidden_field => $value ) {
+ 		$item .= '<input type="hidden" name="' . esc_attr( $hidden_field ) . '" value="' . esc_attr( $value ) . '" />' . "\n";
+ 	}
+ 
+ 	return array(
+ 		'item'   => $item,
+ 		'meta'   => $media_meta,
+ 	);
+ }
+ 
  /**
   * {@internal Missing Short Description}}
   *
   * @since 2.5.0
   */
  function media_upload_header() {
! 	$post_id = isset( $_REQUEST['post_id'] ) ? intval( $_REQUEST['post_id'] ) : 0;
! 	echo '<script type="text/javascript">post_id = ' . $post_id . ";</script>\n";
! 	if ( empty( $_GET['chromeless'] ) ) {
! 		echo '<div id="media-upload-header">';
! 		the_media_upload_tabs();
! 		echo '</div>';
! 	}
  }
  
  /**
***************
*** 1322,1330 ****
  
  ?></div>
  <?php
- // Check quota for this blog if multisite
  if ( is_multisite() && !is_upload_space_available() ) {
! 	echo '<p>' . sprintf( __( 'Sorry, you have filled your storage quota (%s MB).' ), get_space_allowed() ) . '</p>';
  	return;
  }
  
--- 1486,1493 ----
  
  ?></div>
  <?php
  if ( is_multisite() && !is_upload_space_available() ) {
! 	do_action( 'upload_ui_over_quota' );
  	return;
  }
  
***************
*** 1357,1362 ****
--- 1520,1530 ----
  	'multipart_params' => $post_params
  );
  
+ // Multi-file uploading doesn't currently work in iOS Safari,
+ // single-file allows the built-in camera to be used as source for images
+ if ( wp_is_mobile() )
+ 	$plupload_init['multi_selection'] = false;
+ 
  $plupload_init = apply_filters( 'plupload_init', $plupload_init );
  
  ?>
***************
*** 1413,1421 ****
   *
   * @since 2.5.0
   *
!  * @param unknown_type $type
!  * @param unknown_type $errors
!  * @param unknown_type $id
   */
  function media_upload_type_form($type = 'file', $errors = null, $id = null) {
  
--- 1581,1589 ----
   *
   * @since 2.5.0
   *
!  * @param string $type
!  * @param object $errors
!  * @param integer $id
   */
  function media_upload_type_form($type = 'file', $errors = null, $id = null) {
  
***************
*** 1476,1484 ****
   *
   * @since 2.7.0
   *
!  * @param unknown_type $type
!  * @param unknown_type $errors
!  * @param unknown_type $id
   */
  function media_upload_type_url_form($type = null, $errors = null, $id = null) {
  	if ( null === $type )
--- 1644,1652 ----
   *
   * @since 2.7.0
   *
!  * @param string $type
!  * @param object $errors
!  * @param integer $id
   */
  function media_upload_type_url_form($type = null, $errors = null, $id = null) {
  	if ( null === $type )
